SystemOrganization addCategory: #'DuoSystemBrowser3.9'!

!OBColumn methodsFor: '*DuoSystemBrowser3.9-private' stamp: 'rw 6/10/2006 14:48'!
browser

	^panel browser! !

!OBColumn methodsFor: '*DuoSystemBrowser3.9-private' stamp: 'dr 8/3/2006 17:07'!
panel

	^panel ! !

OBColumn subclass: #OBSelectAllCategoryColumn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DuoSystemBrowser3.9'!

!OBSelectAllCategoryColumn methodsFor: 'updating' stamp: 'dr 8/3/2006 22:25'!
selectionChanged: ann
	super selectionChanged: ann.
	"| nextColumn |
	nextColumn := ann column next.
	(nextColumn notNil and: [ann column selectedNode isKindOf: OBClassNode]) ifTrue: [ 
		nextColumn next parent: nextColumn getChildren first]"! !

!OBFilter methodsFor: '*DuoSystemBrowser3.9' stamp: 'dr 8/4/2006 18:39'!
monitor
	^monitor! !

!OBClassAwareNode class methodsFor: '*DuoSystemBrowser3.9-sorting' stamp: 'rw 7/20/2006 15:47'!
sortHierarchicallyOptimized: nodes
	"Reimplements sortHierarchically in a crude and ugly way that is however much more efficient"
	
	| classNodes sortedResults supersChain superior result chain1 chain2 i max |
	classNodes := (nodes collect: [:classNode | classNode theClass]) asOrderedCollection.
	sortedResults := SortedCollection sortBlock: [:assoc1 :assoc2 |
		result := nil.
		chain1 := assoc1 key.
		chain2 := assoc2 key. 
		max := chain1 size min: chain2 size.
		i := 1.
		[result isNil and: [i <= max]] whileTrue: [
			(chain1 at: i) = (chain2 at: i)
				ifTrue: [i := i + 1]
				ifFalse: [result := (chain1 at: i) name < (chain2 at: i) name]].
		result isNil ifTrue: [
			chain1 size < chain2 size] ifFalse: [result]
	].
	nodes do: [:classNode |
		supersChain := classNode theClass withAllSuperclasses reversed.
		supersChain removeAllSuchThat: [:cl | (classNodes includes: cl) not].
		superior := supersChain size > 1
			ifTrue: [superior := supersChain atLast: 2. nodes detect: [:e | e theClass = superior]]
			ifFalse: [nil].
		sortedResults add: supersChain contents -> (classNode superior: superior).
	].
	^(sortedResults collect: [:assoc | assoc value]) asArray! !

OBClassCategoryNode subclass: #MonticelloClassCategoryNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DuoSystemBrowser3.9'!

!MonticelloClassCategoryNode methodsFor: 'accessing' stamp: 'dr 8/1/2006 19:10'!
classesForPackage
	^self classesHierarchically! !

!MonticelloClassCategoryNode methodsFor: 'displaying' stamp: 'dr 8/1/2006 20:09'!
indentedName
	^((Text new: 2) atAllPut: $ ), self name! !

OBNode subclass: #MonticelloPackageNode
	instanceVariableNames: 'mcPackage theClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DuoSystemBrowser3.9'!

MonticelloPackageNode subclass: #MonticelloExtensionPackageNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DuoSystemBrowser3.9'!

!MonticelloExtensionPackageNode methodsFor: 'displaying' stamp: 'rw 7/2/2006 19:57'!
name
	
	^Text string: super name emphasis: (Array with: TextEmphasis italic)! !

!MonticelloPackageNode class methodsFor: 'instance creation' stamp: 'rw 6/10/2006 18:26'!
package: aPackage class: aClass

	^self new mcPackage: aPackage; theClass: aClass! !

!MonticelloPackageNode methodsFor: 'comparing' stamp: 'rw 7/2/2006 20:04'!
= other

	^(other isKindOf: MonticelloPackageNode)
		ifTrue: [self mcPackage = other mcPackage]
		ifFalse: [super = other]! !

!MonticelloPackageNode methodsFor: 'actions' stamp: 'dr 8/4/2006 22:58'!
actions
	^ {
		self action: #addWorkingCopy buttonLabel: 'add package' menuLabel: 'add package'.
		self action: #browseWorkingCopy buttonLabel: 'browse' menuLabel: 'browse'.
		self action: #saveVersion buttonLabel: 'publish' menuLabel: 'publish'.
		self action: #inspect buttonLabel: 'inspect' menuLabel: 'inspect'.
		self action: #removeWorkingCopy buttonLabel: 'remove' menuLabel: 'remove'.
		self action: #viewHistory buttonLabel: 'history' menuLabel: 'history'.
		self action: #viewChanges buttonLabel: 'changes' menuLabel: 'changes'.
		self action: #findClass buttonLabel: 'find class' menuLabel: 'find class'.
		self action: #showComment buttonLabel: 'Comment' menuLabel: 'comment'.
	}! !

!MonticelloPackageNode methodsFor: 'private-actions' stamp: 'rw 7/4/2006 23:37'!
addWorkingCopy

	|name|
	name := FillInTheBlankMorph request: 'Name of package:'.
	name isEmptyOrNil ifTrue: [^self].
	PackageInfo registerPackageName: name.
	MCWorkingCopy forPackage: (MCPackage new name: name).
	self signalChanged! !

!MonticelloPackageNode methodsFor: 'private' stamp: 'rw 7/4/2006 23:41'!
askForRepository

	| reps index |
	reps := self repositories.
	index := (PopUpMenu labelArray: (reps collect: [:rep | rep description]))
				startUpWithCaption: 'Repository:'.
	^(index = 0) ifTrue: [nil] ifFalse: [reps at: index]! !

!MonticelloPackageNode methodsFor: 'private-actions' stamp: 'rw 7/4/2006 22:47'!
browseWorkingCopy

	(MCSnapshotBrowser forSnapshot: mcPackage package snapshot)
			label: 'Snapshot Browser: ', mcPackage packageName;
			show! !

!MonticelloPackageNode methodsFor: 'private' stamp: 'rw 7/4/2006 23:11'!
checkForNewerVersionsIn: repository

	| newer |
	newer := mcPackage possiblyNewerVersionsIn: repository.
	^ newer isEmpty or: [
		self confirm: 'CAUTION!! These versions in the repository may be newer:', 
			String cr, newer asString, String cr,
			'Do you really want to save this version?'].! !

!MonticelloPackageNode methodsFor: 'actions' stamp: 'dr 8/4/2006 20:33'!
classLevelProtocols

	^ theClass class organization categories
		collect: [:cat | (OBMethodCategoryNode on: cat inClass: theClass) browser: self browser]! !

!MonticelloPackageNode methodsFor: 'public' stamp: 'dr 8/4/2006 20:38'!
classes
	"Note: differentiate between classes and extension classes so that I can wrap them differently so that I can control how they are shown, e.g. extension classes in italic."

	| classes extensions | 
	classes := mcPackage packageInfo classes collect: [:each | each asNode: self browser].
	extensions := mcPackage packageInfo extensionClasses collect: [:each | (OBClassExtensionNode on: each theNonMetaClass) browser: self browser]. 
	^(classes asSet addAll: extensions; yourself) asArray! !

!MonticelloPackageNode methodsFor: 'accessing' stamp: 'rw 7/2/2006 18:42'!
classesForPackage
	"return all classes for the selected package"

	^self classesHierarchically! !

!MonticelloPackageNode methodsFor: 'private-actions' stamp: 'rw 7/20/2006 15:26'!
classesHierarchically

	^OBClassAwareNode sortHierarchicallyOptimized: self classes! !

!MonticelloPackageNode methodsFor: 'public' stamp: 'dr 8/4/2006 19:02'!
comments

	^self classes collect: [:each | each theClass asCommentNode: self browser]! !

!MonticelloPackageNode methodsFor: 'public' stamp: 'rw 7/18/2006 17:58'!
commentsHierarchically
	^ OBClassAwareNode sortHierarchicallyOptimized: self comments! !

!MonticelloPackageNode methodsFor: 'private-actions' stamp: 'rw 7/7/2006 14:43'!
findClass

	| pattern foundClassOrTrait package |
	pattern := UIManager default request: 'Class name or fragment?'.
	pattern isEmpty ifTrue: [^ self].
	foundClassOrTrait := Utilities classFromPattern: pattern withCaption: ''.
	foundClassOrTrait ifNil: [^ self].
	package := self packageForClassOrTrait: foundClassOrTrait ifAbsent: [^self].
	(MonticelloPackageNode package: package class: foundClassOrTrait asNode) signalSelection! !

!MonticelloPackageNode methodsFor: 'private' stamp: 'rw 7/4/2006 23:05'!
hasRepository

	^self repositories notEmpty! !

!MonticelloPackageNode methodsFor: 'displaying' stamp: 'dr 8/1/2006 20:07'!
indentedName
	^self name! !

!MonticelloPackageNode methodsFor: 'actions' stamp: 'dr 8/4/2006 20:33'!
instLevelProtocols

	^ theClass organization categories
		collect: [:cat | (OBMethodCategoryNode on: cat inClass: theClass) browser: self browser]! !

!MonticelloPackageNode methodsFor: 'private' stamp: 'rw 7/2/2006 19:53'!
mcPackage

	^mcPackage! !

!MonticelloPackageNode methodsFor: 'private' stamp: 'rw 6/4/2006 21:17'!
mcPackage: aWorkingCopy

	mcPackage := aWorkingCopy! !

!MonticelloPackageNode methodsFor: 'public' stamp: 'dr 8/4/2006 19:02'!
metaclasses

	^self classes collect: [:each | each theClass asClassSideNode: self browser]! !

!MonticelloPackageNode methodsFor: 'public' stamp: 'rw 7/18/2006 17:58'!
metaclassesHierarchically

	^ OBClassAwareNode sortHierarchicallyOptimized: self metaclasses! !

!MonticelloPackageNode methodsFor: 'public' stamp: 'rw 6/5/2006 08:35'!
name
	^mcPackage packageName! !

!MonticelloPackageNode methodsFor: 'private-actions' stamp: 'rw 7/7/2006 14:35'!
packageForClassOrTrait: classOrTrait ifAbsent: absentblock

	MCWorkingCopy allManagers do: [:wc |
		(wc package packageInfo classes includes: classOrTrait)
			ifTrue: [^wc]
	].
	^absentblock value! !

!MonticelloPackageNode methodsFor: 'private-actions' stamp: 'rw 7/4/2006 23:38'!
removeWorkingCopy

	(PopUpMenu confirm: 'Really remove package?')
		ifTrue: [mcPackage unregister. self signalDeletion]! !

!MonticelloPackageNode methodsFor: 'private' stamp: 'rw 7/4/2006 23:05'!
repositories

	^mcPackage repositoryGroup repositories! !

!MonticelloPackageNode methodsFor: 'private-actions' stamp: 'rw 7/5/2006 08:45'!
saveVersion
	| repository |
	self hasRepository ifFalse: [^self].
	repository := self askForRepository.
	(self checkForNewerVersionsIn: repository) ifFalse: [^self].
	mcPackage newVersion ifNotNilDo:
		[:v |
		(MCVersionInspector new version: v) show.
		Cursor wait showWhile: [repository storeVersion: v].
		v allAvailableDependenciesDo:
			[:dep |
			(repository includesVersionNamed: dep info name)
				ifFalse: [repository storeVersion: dep]]]
! !

!MonticelloPackageNode methodsFor: 'actions' stamp: 'dr 8/4/2006 23:06'!
showComment
	| defPanel columnPanel classColumn |

	defPanel := self browser panels last.
	columnPanel := self browser panels first.
	classColumn := columnPanel columnBefore: columnPanel currentColumn.
	classColumn ifNotNil: [
	    (defPanel isKindOf: OBDefinitionPanel) ifTrue: [defPanel definition: (OBClassCommentNode on: theClass)].
	].! !

!MonticelloPackageNode methodsFor: 'accessing' stamp: 'rw 7/4/2006 23:21'!
text
	| str |
	str := WriteStream on: String new.
	str
		nextPutAll: 'Monticello Package: ';
		nextPutAll: mcPackage package name;
		cr; cr.
	^str contents! !

!MonticelloPackageNode methodsFor: 'accessing' stamp: 'rw 6/10/2006 14:03'!
theClass: aClassNode

	theClass := aClassNode theClass! !

!MonticelloPackageNode methodsFor: 'private-actions' stamp: 'rw 7/4/2006 23:17'!
viewChanges

	| patch repository |
	self hasRepository ifFalse: [^self].
	repository := self askForRepository.
	patch := mcPackage changesRelativeToRepository: repository.
	patch isNil ifTrue: [^ self].
	patch isEmpty
		ifTrue: [ mcPackage modified: false.
				self inform: 'No changes' ]
		ifFalse:
				[ mcPackage modified: true.
				(MCPatchBrowser forPatch: patch)
					label: 'Patch Browser: ', mcPackage description;
					show]! !

!MonticelloPackageNode methodsFor: 'private-actions' stamp: 'rw 7/4/2006 22:55'!
viewHistory

	mcPackage ifNil: [^self].
	(MCWorkingHistoryBrowser new
				ancestry: mcPackage ancestry;
				package: mcPackage package)
			label:  'Version History: ',  mcPackage packageName;
			show! !

OBNode subclass: #PackagesOrClassesNode
	instanceVariableNames: 'mcPackage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DuoSystemBrowser3.9'!

!PackagesOrClassesNode methodsFor: 'private-hacks' stamp: 'rw 6/9/2006 00:45'!
browser: aBrowser

	browser := aBrowser! !

!PackagesOrClassesNode methodsFor: 'private' stamp: 'dr 8/1/2006 19:50'!
classCategoriesForPackage: wc
	^self class environment organization categoriesMatching: wc packageName, '-*'.! !

!PackagesOrClassesNode methodsFor: 'accessing' stamp: 'dr 8/4/2006 19:00'!
classesHierarchically

	| selectedClass classesToShow | 
	selectedClass := self secondPaneSelection.
	selectedClass isNil
		ifTrue: [^Smalltalk allClasses collect: [:each | each asNode: self browser]].
	classesToShow := self treeAround: selectedClass.
	^OBClassAwareNode sortHierarchicallyOptimized: classesToShow! !

!PackagesOrClassesNode methodsFor: 'private' stamp: 'rw 6/9/2006 01:07'!
mcPackage: aWorkingCopy

	mcPackage := aWorkingCopy! !

!PackagesOrClassesNode methodsFor: 'private' stamp: 'rw 6/9/2006 00:46'!
mcRepository

	^MCCacheRepository default! !

!PackagesOrClassesNode methodsFor: 'public' stamp: 'rw 6/9/2006 00:44'!
name

	^self mcRepository description! !

!PackagesOrClassesNode methodsFor: 'accessing' stamp: 'dr 8/4/2006 19:03'!
packages

	| workingCopies packages |
	workingCopies _ MCWorkingCopy allManagers asSortedCollection:
		[ :a :b | a package name <= b package name ].

	packages _ OrderedCollection new. 
	workingCopies do: [:wc | |packageNode | 
		    packageNode := (MonticelloPackageNode new mcPackage: wc; browser: self browser).
		    packages add: packageNode. 
		    (self classCategoriesForPackage: wc) do: [:classCategory |
		           packages add: ((MonticelloClassCategoryNode on: classCategory) browser: self browser)]].
	^packages! !

!PackagesOrClassesNode methodsFor: 'private-hacks' stamp: 'rw 6/9/2006 00:46'!
secondPaneSelection

	| column |
	browser isNil ifTrue: [^self].
	column := browser panels first columns second.
	^column selectedNode! !

!PackagesOrClassesNode methodsFor: 'accessing' stamp: 'rw 6/9/2006 00:45'!
text

	^'Euh - something regarding an MCCachedRepository ?!!'! !

!PackagesOrClassesNode methodsFor: 'private' stamp: 'dr 8/4/2006 20:36'!
treeAround: aClass
	"Return a collection with the complete hierarchy of aClass, and with the chain of aClass up to Object"


	^(aClass theClass withAllSubclasses
		addAll: aClass theClass allSuperclasses;
		yourself)	
			collect: [:each | each asNode: self browser]! !

OBBrowser subclass: #DuoSystemBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DuoSystemBrowser3.9'!

!DuoSystemBrowser class methodsFor: 'configuration' stamp: 'dr 8/4/2006 20:19'!
defaultMetaNode
	"self open"

	| root class method protocol classes packagesForClass packages |
	root := OBMetaNode named: 'root'.
	packages := OBMetaNode named: 'packages'.
	classes := OBMetaNode named: 'classes'.
	packagesForClass := OBMetaNode named: 'packagesForClass'.
	class := OBMetaNode named: 'class'.
	protocol := OBMetaNode named: 'protocol'.
	method := OBMetaNode named: 'method'.
	
	root
		childAt: #packages labeled: 'package' put: packages;
		childAt: #classesHierarchically labeled: 'hierarchy' put: classes;
		filterClass: ModalDuoFilter;
		columnClass: OBSelectAllCategoryColumn.

	packages
		displaySelector: #indentedName;
		childAt: #classesForPackage put: class;	
		columnClass: OBSelectAllCategoryColumn;		
		addActor: OBNodeActor new.
		
	classes
		displaySelector: #indentedName;	
		columnClass: OBSelectAllCategoryColumn;	
		addActor: OBNodeActor new;
		addActor: OBClassActor new;
		childAt: #packagesForClass put: packagesForClass.		
		
	packagesForClass
		childAt: #instLevelProtocols labeled: 'instance' put: protocol;	
		childAt: #classLevelProtocols labeled: 'class' put: protocol;
		addActor: OBNodeActor new;
		columnClass: OBSelectAllCategoryColumn;	
		filterClass: OBModalFilter.
		
	class
		displaySelector: #indentedName;
		childAt: #instLevelProtocols labeled: 'instance' put: protocol;
		childAt: #classLevelProtocols labeled: 'class' put: protocol;		
		addActor: (OBNodeActor onNodeClass: OBClassCategoryNode);
		addActor: OBClassActor new;
		columnClass: OBSelectAllCategoryColumn;	
		filterClass: OBModalFilter.
			
	protocol
		childAt: #methods put: method;	
		addActor: OBCategoryActor new;
		addActor: (OBNodeActor onNodeClass: OBMethodCategoryNode).
		
	method addActor: OBNodeActor new. 
	^root! !

!DuoSystemBrowser class methodsFor: 'configuration' stamp: 'rw 6/10/2006 17:54'!
defaultRootNode
	"self open"

	^PackagesOrClassesNode new! !

!DuoSystemBrowser class methodsFor: 'configuration' stamp: 'dr 8/4/2006 20:10'!
optionalButtons
	^#('Source' 'Comment' 'browse' 'variables' 'senders' 'implementors')! !

!DuoSystemBrowser class methodsFor: 'configuration' stamp: 'rw 6/9/2006 00:40'!
title
	^ 'VWBrowser'! !

!DuoSystemBrowser methodsFor: 'initialize' stamp: 'dr 8/4/2006 19:04'!
setMetaNode: aMetaNode node: aNode 
	aNode browser: self.
	super setMetaNode: aMetaNode node: aNode. 
! !

TestCase subclass: #SortHierarchicallyTests
	instanceVariableNames: 'completeTree partialTree unrelatedClasses archivesClasses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DuoSystemBrowser3.9'!

!SortHierarchicallyTests methodsFor: 'private' stamp: 'rw 7/7/2006 17:09'!
asNodes: classCollection

	^classCollection collect: [:cl | cl asNode]! !

!SortHierarchicallyTests methodsFor: 'private' stamp: 'rw 7/18/2006 17:56'!
nodes: nodes shouldBe: correctNodes
	"sort the collection of nodes. The result should be the correctNodes"

	| sorted |
	sorted := OBClassAwareNode sortHierarchicallyOptimized: nodes asArray.
	self assert: sorted size = correctNodes size.
	correctNodes with: sorted do: [:node :sortedNode | self assert: node = sortedNode]! !

!SortHierarchicallyTests methodsFor: 'setup' stamp: 'rw 7/20/2006 13:25'!
setUp

	completeTree := self asNodes: {String . ByteString . Symbol . ByteSymbol . WideSymbol . WideString} .
	partialTree := self asNodes: {String . ByteString . ByteSymbol . WideString}.
	unrelatedClasses := self asNodes: {ArrayedCollection . BlockClosure . Class . Compiler . Morph . Point}.
	archivesClasses :=  self asNodes: {Archive . TarArchive . ZipArchive . ArchiveMember . TarArchiveMember . ZipArchiveMember . ZipFileMember . ZipDirectoryMember . ZipNewFileMember . ZipStringMember . ZipFileConstants}! !

!SortHierarchicallyTests methodsFor: 'private' stamp: 'rw 7/7/2006 17:33'!
sortByNameSize: collection

	^collection asSortedCollection: [:x :y | x theClass name size < y theClass name size]! !

!SortHierarchicallyTests methodsFor: 'tests' stamp: 'rw 7/20/2006 13:24'!
testArchivesClassesReversed

	self
		nodes: archivesClasses reversed
		shouldBe: archivesClasses! !

!SortHierarchicallyTests methodsFor: 'tests' stamp: 'rw 7/20/2006 13:24'!
testArchivesClassesUnchanged

	self
		nodes: archivesClasses
		shouldBe: archivesClasses! !

!SortHierarchicallyTests methodsFor: 'tests' stamp: 'rw 7/20/2006 13:24'!
testArchivesClassesUnordered

	self
		nodes: (self sortByNameSize: archivesClasses)
		shouldBe: archivesClasses
		
	! !

!SortHierarchicallyTests methodsFor: 'tests' stamp: 'rw 7/7/2006 17:26'!
testCompleteTreeReversed

	self
		nodes: completeTree reversed
		shouldBe: completeTree! !

!SortHierarchicallyTests methodsFor: 'tests' stamp: 'rw 7/7/2006 17:26'!
testCompleteTreeUnchanged

	self
		nodes: completeTree
		shouldBe: completeTree! !

!SortHierarchicallyTests methodsFor: 'tests' stamp: 'rw 7/7/2006 17:33'!
testCompleteTreeUnordered

	self
		nodes: (self sortByNameSize: completeTree)
		shouldBe: completeTree! !

!SortHierarchicallyTests methodsFor: 'tests' stamp: 'rw 7/18/2006 18:13'!
testOneClass

	| pointNode sorted |
	pointNode := Point asNode.
	sorted := OBClassAwareNode sortHierarchicallyOptimized: (Array with: pointNode).
	self assert: sorted size = 1.
	self assert: (sorted includes: pointNode)! !

!SortHierarchicallyTests methodsFor: 'tests' stamp: 'rw 7/7/2006 17:29'!
testPartialTreeReversed

	self
		nodes: partialTree reversed
		shouldBe: partialTree! !

!SortHierarchicallyTests methodsFor: 'tests' stamp: 'rw 7/7/2006 17:27'!
testPartialTreeUnchanged

	self
		nodes: partialTree
		shouldBe: partialTree! !

!SortHierarchicallyTests methodsFor: 'tests' stamp: 'rw 7/7/2006 17:34'!
testPartialTreeUnsorted

	self
		nodes: (self sortByNameSize: partialTree)
		shouldBe: partialTree! !

!SortHierarchicallyTests methodsFor: 'tests' stamp: 'rw 7/7/2006 17:31'!
testUnrelatedClassesReversed

	self
		nodes: unrelatedClasses reversed
		shouldBe: unrelatedClasses! !

!SortHierarchicallyTests methodsFor: 'tests' stamp: 'rw 7/7/2006 17:31'!
testUnrelatedClassesUnchanged

	self
		nodes: unrelatedClasses
		shouldBe: unrelatedClasses! !

!SortHierarchicallyTests methodsFor: 'tests' stamp: 'rw 7/7/2006 17:34'!
testUnrelatedClassesUnsorted

	self
		nodes: (self sortByNameSize: unrelatedClasses)
		shouldBe: unrelatedClasses! !

OBModalFilter subclass: #ModalDuoFilter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DuoSystemBrowser3.9'!

!ModalDuoFilter methodsFor: 'private-hacks' stamp: 'rw 6/10/2006 18:16'!
firstPaneSelection

	^monitor selectedNode! !

!ModalDuoFilter methodsFor: 'private-hacks' stamp: 'cwp 6/11/2006 13:00'!
secondPaneSelection

	^ monitor next selectedNode! !

!ModalDuoFilter methodsFor: 'callbacks' stamp: 'rw 7/2/2006 20:04'!
selection: anInteger

	| secondSelection firstSelection |
	firstSelection := self firstPaneSelection.
	secondSelection := self secondPaneSelection.
	super selection: anInteger.
	monitor select: secondSelection.
	self setSecondPaneSelection: firstSelection.! !

!ModalDuoFilter methodsFor: 'private-hacks' stamp: 'cwp 6/11/2006 13:05'!
setSecondPaneSelection: aNode

	monitor next select: aNode! !

!OBMethodCategoryNode methodsFor: '*DuoSystemBrowser3.9' stamp: 'dr 8/4/2006 15:59'!
definition: aDefinition
	definition := aDefinition! !

OBClassNode subclass: #OBClassExtensionNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DuoSystemBrowser3.9'!

!OBClassExtensionNode methodsFor: 'displaying' stamp: 'dr 8/1/2006 22:13'!
indentedName
	
	^Text string: super indentedName asString emphasis: {TextEmphasis italic} ! !

!OBClassNode methodsFor: '*DuoSystemBrowser3.9' stamp: 'rw 7/2/2006 19:29'!
= anObject

	^(anObject isKindOf: OBClassNode)
		ifTrue: [self theClass = anObject theClass]
		ifFalse: [super = anObject]! !

!OBClassNode methodsFor: '*DuoSystemBrowser3.9' stamp: 'dr 8/4/2006 20:28'!
classLevelProtocols
	| protocols |
	protocols := OrderedCollection with: ((OBAllMethodCategoryNode on: self theClass class) browser: self browser).
	protocols addAll: (self theClass class organization categories 
	                          collect: [:cat | (OBMethodCategoryNode on: cat inClass: self theClass) browser: self browser]).
	^protocols	! !

!OBClassNode methodsFor: '*DuoSystemBrowser3.9' stamp: 'rw 8/16/2006 11:19'!
extensionPackageNames

	| names packageNameIndex |
	names := Set new.
	(theClass theNonMetaClass organization categories asOrderedCollection addAll: theClass theMetaClass organization categories) do: [:cat |
		(cat first = $*) ifTrue: [
			packageNameIndex := (cat indexOf: $-) - 1.
			packageNameIndex = -1 ifTrue: [packageNameIndex := cat size].
			names add: (cat copyFrom: 2 to: packageNameIndex) asLowercase].
	].
	^names! !

!OBClassNode methodsFor: '*DuoSystemBrowser3.9' stamp: 'dr 8/4/2006 20:28'!
instLevelProtocols
	| protocols |
	protocols := OrderedCollection with: ((OBAllMethodCategoryNode on: self theClass) browser: self browser).
	protocols addAll: (self theClass organization categories 
	                          collect: [:cat | (OBMethodCategoryNode on: cat inClass: self theClass) browser: self browser]).
	^protocols! !

!OBClassNode methodsFor: '*DuoSystemBrowser3.9' stamp: 'dr 8/4/2006 20:29'!
packagesForClass
	"return the package this class is defined in, as well as the packages that extend it."
	"Needs to be cleaned up and refactored since this is ugly..."

	| extensionPackages info definitionPackage extensionNames |
	extensionPackages := OrderedCollection new.
	extensionNames := self extensionPackageNames.
	MCWorkingCopy allManagers do: [:wc |
		info := wc package packageInfo.
		(info classes includes: theClass)
			ifTrue: [definitionPackage := (MonticelloPackageNode package: wc class: self) browser: self browser]
			ifFalse: [(extensionNames includes: wc package name asLowercase)
						ifTrue: [extensionPackages add: ((MonticelloExtensionPackageNode package: wc class: self) browser: self browser)]]
	].

	^(OrderedCollection with: definitionPackage) addAll: extensionPackages; yourself! !
